// Copyright (C) 1999 Dominic Letourneau
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _NETWORKLOGGER_CC_
#define _NETWORKLOGGER_CC_

#include "NetworkLogger.h"
#include "stdio.h"
#include <time.h>

NetworkLogger::NetworkLogger (ostream &out) { 
   output = &out;
   //semaphore = NULL;
   //let's obtain a semaphore
   /*
   if ((sem_init (&semaphore, 1, 1)) == -1) {

      cout<<"Unable to create the semaphore..."<<endl;

      switch (errno) {
           
      case EPERM:
         cerr<<"The calling process does not have the privileges necessary "
             <<"to initialize the semaphore."<<endl;
         break;     

      case EBUSY:    
         cerr<<"There are threads currently blocked on the semaphore or "
             <<"there are outstanding locks held on the semaphore."<<endl;
         break;
                       
      case EINVAL: 
         cerr<<"The argument value is greater than {_POSIX_SEM_VALUE_MAX}."<<endl;
         break;              

      case ENOSPC:    
         cerr<<"There are insufficient resources to perform the operation or "
             <<"the upper limit on the number of semaphores is reached."<<endl;

         break;  
      default:
         perror("Unknown error : ");
      }

   }
   */

}
NetworkLogger::~NetworkLogger () {
   //sem_destroy (&semaphore);
}

void NetworkLogger::WriteLog(const string &data){ 
   obtainSemaphore();
   //critical section
   char value[32];
   time_t a_time = time (NULL);
   struct tm *a_time_struct = localtime(&a_time);
   strftime (value,32,"%c",a_time_struct);                              
   (*output)<<value<<" "<<data<<flush;
   releaseSemaphore();
}

void NetworkLogger::WriteLog(BaseException *exception) {
   obtainSemaphore();
   //critical section
   char value[32];
   time_t a_time = time(NULL);
   struct tm *a_time_struct = localtime(&a_time);
   strftime (value,32,"%c",a_time_struct);   
   (*output)<<value<<" ";
   exception->print(*output);
   (*output)<<flush;
   releaseSemaphore();
}

void NetworkLogger::obtainSemaphore() {
   //sem_wait(&semaphore);
}

void NetworkLogger::releaseSemaphore() {
   //sem_post(&semaphore);
}

#endif
