#include <stream.h>
#include <fstream.h>
#include <math.h>
#include <vector>
#include <string>
#include <map>

#define SIZE 4096
#define DIV 1
/*
float cos_dist(int *x2, int *x1, int len)
{
   float sx=0,sy=0,d=0;
   for (int i=0;i<len;i++)
   {
      sy+=x2[i];
      sx+=x1[i];
   }
   sx=1/sx;
   sy=1/sy;
   for (int i=0;i<len;i++)
   {
      d+=x2[i]*log(sx*(1+x1[i]));
   }
   return d*sy;
}
*/


float cos_dist(int *x1, int *x2, int len)
{
   double xx=0,xy=0,yy=0;
   double sx=0,sy=0;
   for (int i=0;i<len;i++)
   {
      sy+=x2[i];
      sx+=x1[i];
   }
   sx/=len;
   sy/=len;
   for (int i=0;i<len;i++)
   {
      //cerr << x1[i] << " " << x2[i] << endl;
      xx+=(x1[i]-sx)*(x1[i]-sx);
      xy+=(x1[i]-sx)*(x2[i]-sy);
      yy+=(x2[i]-sy)*(x2[i]-sy);
   }
   return xy/sqrt(xx*yy);
}


/*
float cos_dist(int *x1, int *x2, int len)
{
   double xx=0,xy=0,yy=0;
   for (int i=0;i<len;i++)
   {
      //cerr << x1[i] << " " << x2[i] << endl;
      xx+=x1[i]*x1[i];
      xy+=x1[i]*x2[i];
      yy+=x2[i]*x2[i];
   }
   return xy/sqrt(xx*yy);
}
*/
typedef int I2[2];
int main (int argc, char **argv)
{
   ifstream fTestFiles(argv[1]);
   ifstream fTrainFiles(argv[2]);
   ifstream fAnswers(argv[3]);
   string dummy;

   vector<string> testFiles;
   vector<string> trainFiles;
   map<string,int> trainMap;
   map<string,int> chA;
   map<string,int> chB;

   while (1)
   {
      string tmp;
      fTestFiles >> tmp;
      if (!fTestFiles)
         break;
      testFiles.insert(testFiles.end(), tmp);
   }

   while (1)
   {
      string tmp;
      fTrainFiles >> tmp;
      if (!fTrainFiles)
         break;
      trainMap[tmp]=trainFiles.size();
      trainFiles.insert(trainFiles.end(), tmp);
   }

   while (1)
   {
      string tmp1, tmp2, tmp3;
      fAnswers >> tmp1;
      if (!fAnswers)
         break;
      fAnswers >> tmp2;
      fAnswers >> tmp3;
      if (tmp2 != "xxxx")
      {
         if (trainMap.find(tmp2)!=trainMap.end())
            chA[tmp1]=trainMap[tmp2];
         else
            chA[tmp1]=-1;
         //chA[tmp1]=trainMap[tmp2];
      } else {
         chA[tmp1]=-1;
         //cout << "xxxx\n";
      }

      if (tmp3 != "xxxx")
      {
         if (trainMap.find(tmp3)!=trainMap.end())
            chB[tmp1]=trainMap[tmp3];
         else
            chB[tmp1]=-1;
      } else {
         chB[tmp1]=-1;
         //cout << "xxxx\n";
      }
      
   }
   //exit(0);
   //cout << trainFiles[0] << " " << testFiles[0] << endl;

   int *train = new int [SIZE*trainFiles.size()];
   
   for (int i=0;i<trainFiles.size();i++)
   {
      string name = "/home/jm/contrat/tests/speakerID/20000110/training/" 
                    + trainFiles[i] + "a.sph";
      ifstream tmpTrain(name.c_str());
      tmpTrain >> dummy;
      for (int j=0;j<SIZE;j++)
      {
         train[i*SIZE+j] = 0;
         for (int k=0;k<DIV;k++)
         {
            int tmp;
            tmpTrain >> tmp;
            train[i*SIZE+j] += tmp;
         }
      }
   }
   /*
   for (int i=0;i<trainFiles.size();i++)
   {
      string name = "/home/jm/contrat/tests/speakerID/20000110/training/" 
                    + trainFiles[i] + "b.sph";
      ifstream tmpTrain(name.c_str());
      tmpTrain >> dummy;
      for (int j=0;j<SIZE;j++)
      {
         //train[i*SIZE+j] = 0;
         for (int k=0;k<DIV;k++)
         {
            int tmp;
            tmpTrain >> tmp;
            train[i*SIZE+j] += tmp;
         }
      }
   }
   */
   /*
   int fact=1;
   int shift=0;
   for (int i=0;i<4;i++)
   {
      fact*=2;
      shift+=1;
      for (int j=0;j<SIZE/fact;j++)
      {
         int sum=0;
         for (int k=0;k<fact;k++)
            sum+=train[j*fact+k];
         sum >>= shift;
         for (int k=0;k<fact;k++)
            train[j*fact+k]+=sum;
      }
   }
   */

   int *test = new int [SIZE*testFiles.size()];
   
   for (int i=0;i<testFiles.size();i++)
   {
      string name = "/home/jm/contrat/tests/speakerID/20000110/training/" 
      //string name = "/home/jm/contrat/tests/speakerID/20000110/testing/" 
                    + testFiles[i] + ".sph";
      //cout << i << " " << name << endl;
      //if (name == "/home/jm/contrat/tests/speakerID/20000106/training/4685b.sph")
      //   cerr << "TEST: " << i << endl;
      //name = "/home/jm/contrat/tests/speakerID/20000106/training/4685b.sph";
      //cout << name << endl;
      ifstream tmpTest(name.c_str());
      tmpTest >> dummy;
      for (int j=0;j<SIZE;j++)
      {
         test[i*SIZE+j] = 0;
         for (int k=0;k<DIV;k++)
         {
            int tmp;
            tmpTest >> tmp;
            test[i*SIZE+j] += tmp;
         }
      }
   }

   /*
   fact=1;
   shift=0;
   for (int i=0;i<4;i++)
   {
      fact*=2;
      shift+=1;
      for (int j=0;j<SIZE/fact;j++)
      {
         int sum=0;
         for (int k=0;k<fact;k++)
            sum+=test[j*fact+k];
         sum >>= shift;
         for (int k=0;k<fact;k++)
            test[j*fact+k]+=sum;
      }
   }
   */

   //cout << test[9] << " " << train[6] << endl;
   //cout << cos_dist (test, train, SIZE) << endl;

   for (int i=0;i<testFiles.size();i++)
   {
      float true_scoreA=-10,true_scoreB=-10;
      int beatenA=0,beatenB=0;
      if (chA[testFiles[i]] == -1 && chB[testFiles[i]] == -1)
         continue;
      if (chA[testFiles[i]] != -1)
         true_scoreA=cos_dist (&(test[i*SIZE]), &(train[(chA[testFiles[i]])*SIZE]), SIZE);
      if (chB[testFiles[i]] != -1)
         true_scoreB=cos_dist (&(test[i*SIZE]), &(train[(chB[testFiles[i]])*SIZE]), SIZE);

      //true_score=cos_dist (&(test[i*SIZE]), &(train[i*SIZE]), 4096);
      for (int j=0;j<trainFiles.size();j++)
      {
         if (cos_dist (&(test[i*SIZE]), &(train[j*SIZE]), SIZE) > true_scoreA)
            beatenA++;
         if (cos_dist (&(test[i*SIZE]), &(train[j*SIZE]), SIZE) > true_scoreB)
            beatenB++;
      }
      //cout << testFiles[i] << "  " << true_scoreA << "\t" << beatenA 
      //     << "\t" << true_scoreB << "\t" << beatenB << endl;
      cout << testFiles[i] << "\t" << min(beatenA,beatenB) << "\t"
           << max(true_scoreA,true_scoreB) << endl;
      /*if (!(true_scoreA > -1.0 || true_scoreB > -1.0))
        cout << "ERROR " << true_scoreA <<" " << true_scoreB << " " << endl;*/
   }

   delete [] train;
   delete [] test;
}
