#include "UINetTerminal.h"
#include "UITerminal.h"
#include "UINode.h"
#include "UINetwork.h"



UINetTerminal::UINetTerminal(/*double _x, double _y, */UITerminal *_terminal, NetTermType _type, string _name)
   //: x(_x)
   //, y(_y)
   : terminal(_terminal)
   , type(_type)
   , name(_name)
{


   terminal->getNode()->getNetwork()->addTerminal(this);
   terminal->connectNetTerminal (this);
}

UINetTerminal::~UINetTerminal()
{
   terminal->getNode()->getNetwork()->removeTerminal(this);
   terminal->disconnectNetTerminal();
}

void UINetTerminal::setName(const string &_name)
{
   name = _name;
}

void UINetTerminal::saveXML(xmlNode *root)
{
   xmlNodePtr tree;

   if (type == INPUT)
      tree = xmlNewChild(root, NULL, (CHAR *)"NetInput", NULL);
   else if (type == OUTPUT)
      tree = xmlNewChild(root, NULL, (CHAR *)"NetOutput", NULL);
   else
      tree = xmlNewChild(root, NULL, (CHAR *)"NetCondition", NULL);

   /*char tmp[15];
   sprintf (tmp, "%f", float(x1));
   xmlSetProp(tree, (CHAR *)"x1", (CHAR *)tmp);
   sprintf (tmp, "%f", float(y1));
   xmlSetProp(tree, (CHAR *)"y1", (CHAR *)tmp);
   sprintf (tmp, "%f", float(x2));
   xmlSetProp(tree, (CHAR *)"x2", (CHAR *)tmp);
   sprintf (tmp, "%f", float(y2));
   xmlSetProp(tree, (CHAR *)"y2", (CHAR *)tmp);*/


   xmlSetProp(tree, (CHAR *)"name", (CHAR *)name.c_str());
   xmlSetProp(tree, (CHAR *)"node", (CHAR *)terminal->getNode()->getName().c_str());
   xmlSetProp(tree, (CHAR *)"terminal", (CHAR *)terminal->getName().c_str());

   /*   xmlSetProp(tree, (CHAR *)"from", (CHAR *)from->getNode()->getName().c_str());
   xmlSetProp(tree, (CHAR *)"output", (CHAR *)from->getName().c_str());
   xmlSetProp(tree, (CHAR *)"to", (CHAR *)to->getNode()->getName().c_str());
   xmlSetProp(tree, (CHAR *)"input", (CHAR *)to->getName().c_str());
   */
}
